/* jshint node: true, loopfunc: true, undef: true, unused: true */
///* global */

var Route = require('zfinder-route');
var arrayUtils = require('zero-lang/array');
var declare = require('zero-oop/declare');
var json = require('zero-encoding/json');

module.exports = declare({
    constructor: function() {
        var me = this;
        me._routes = [];
    },
    getRoutes: function() {
        return this._routes;
    },
    addRoute: function(route) {
        var me = this;
        if (me.validateRoute(route) && !arrayUtils.contains(me._routes, route)) {
            route.middleware = me;
            me._routes.push(route);
        } else {
            if (process.env.ZFINDER_DEBUG) {
                console.error('invalid route!\n' + json.stringify(route));
            }
        }
        return me;
    },
    addRoutes: function(routes) {
        var me = this;
        arrayUtils.each(routes || [], function(route) {
            me.addRoute(route);
        });
        return me;
    },
    validateRoute: function(route) {
        //FIXME: cannot validate routes like this, because there are different versions
        //if (!(route instanceof Route)) {
        //    return false;
        //}
        return true;
    }
});

